// ----------------------------------------------------------------------------
//
// output.cc
// test of RT++ output
//
// $Id: output.cc,v 1.3 1996/04/04 07:06:30 schreine Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Atom(char);
ThreadRes(int);
ThreadArg1(S, int, char);

int output(char c)
{
  for (int k = 0; k < 20; k++)
    {
      rt_lock();
      cout << rt_proc() ;
      for (int i=0; i < 70; i++) cout << c;
      cout << "\n";
      rt_unlock();
      for (int j=0; j < 10000; j++) {}
    }
  return(0);
}

int output(int, char *[])
{
  rt_gc();
  Thread1<int, char> t(output, '-');
  Thread1<int, char> u(output, '.');
  Thread1<int, char> v(output, 'o');
  rt_yield();
  Wait(t);
  Wait(u);
  Wait(v);
  rt_gc();
  return(0);
}

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(output, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of output.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
